Bug 34825 - NullPointerException when transferring byte array over IPC using AIDL
Summary: NullPointerException when transferring byte array over IPC using AIDL
Status: RESOLVED FIXED
Alias: None
Product: Android
Classification: Xamarin
Component: BCL Class Libraries (show other bugs)
Version: 6.1.0 (C7)
Hardware: PC Windows
: --- normal
Target Milestone: ---
Assignee: Atsushi Eno
URL:
Depends on:
Blocks:
 
Reported: 2015-10-13 13:00 UTC by Antao Almada
Modified: 2016-08-09 14:53 UTC (History)
1 user (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on Developer Community or GitHub with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Antao Almada 2015-10-13 13:00:28 UTC
If a method in a AIDL-specified interface contains a byte[] argument, a NullPointerException is thrown.
The OnTransact() method in the generated stub initializes the buffer to null, instead of allocating it before calling Parcel.ReadByteArray. Seems to be wrongly using the same rule used for other data types.
This issue was previously reported in the forum: http://forums.xamarin.com/discussion/47305/nullpointerexception-when-transferring-byte-array-over-ipc-using-aidl
Comment 1 Atsushi Eno 2015-10-19 11:33:31 UTC
Our C# port of AIDL is missing call to Create[Byte_or_anything]Array() to create an assignable array. Now we got an internal fix, and it will be included in the next major update. Thanks for the report.

[master 6422c35]
Comment 2 Antao Almada 2016-05-24 17:40:51 UTC
It's been 7 months and still no fix on latest stable version.
I'm using Xamarin for Android 6.0.4.0 and still have to fix the stub by hand.
Comment 3 Antao Almada 2016-06-24 15:27:32 UTC
Looks like I already had the fix but it doesn't work... :(

The latest version (Xamarin.Android 6.1.1.1) generates the following code:

byte [] arg0 = default (byte []);
arg0 = data.CreateByteArray (); data.ReadByteArray (arg0);

and then I get: Java.Lang.RuntimeException: bad array length

If I replace the generated code again by:

byte[] arg0 = data.CreateByteArray();

The documentation for CreateByteArray() states: Read and return a byte[] object from the parcel.

So the ReadByteArray() call is unnecessary.
Comment 4 Atsushi Eno 2016-08-09 12:29:21 UTC
I got another fix for that: https://github.com/xamarin/xamarin-android/pull/151
Comment 5 Atsushi Eno 2016-08-09 14:53:01 UTC
The fix has landed. [master 13820dc]